<?php

namespace App\Repository;

use App\Entity\Stock;
use DateTime;
use Doctrine\Bundle\DoctrineBundle\Repository\ServiceEntityRepository;
use Doctrine\Persistence\ManagerRegistry;

/**
 * @extends ServiceEntityRepository<Stock>
 *
 * @method Stock|null find($id, $lockMode = null, $lockVersion = null)
 * @method Stock|null findOneBy(array $criteria, array $orderBy = null)
 * @method Stock[]    findAll()
 * @method Stock[]    findBy(array $criteria, array $orderBy = null, $limit = null, $offset = null)
 */
class StockRepository extends ServiceEntityRepository
{
    private $batch = [];

    public function __construct(ManagerRegistry $registry)
    {
        parent::__construct($registry, Stock::class);
    }

    public function save(Stock $entity, bool $flush = false): void
    {
        $entity->setUpdateTime(new DateTime());

        $this->getEntityManager()->persist($entity);

        if ($flush) {
            $this->getEntityManager()->flush();
        }
    }

    public function remove(Stock $entity, bool $flush = false): void
    {
        $this->getEntityManager()->remove($entity);

        if ($flush) {
            $this->getEntityManager()->flush();
        }
    }

    /**
     * @return Stock[] Returns an array of Stock objects
     */
    public function findByWarehouseId(int $warehouseId): array
    {
        return $this->createQueryBuilder('s')
            ->join('s.warehouse', 'w')
            ->andWhere('w.warehouse_id = :val')
            ->setParameter('val', $warehouseId)
            ->orderBy('s.id', 'ASC')
            ->getQuery()
            ->getResult();
    }

    public function add(Stock $stock): void
    {
        $this->batch[] = $stock;
    }

    public function saveAll(): void
    {
        if (empty($this->batch)) {
            return;
        }

        foreach ($this->batch as $stock) {
            $this->getEntityManager()->persist($stock);
        }
        $this->getEntityManager()->flush();
        $this->batch = [];
    }
}